%define intl_major 8
%define major 0
%define libintl %mklibname intl %{intl_major}
%define libasprintf %mklibname asprintf %{major}
%define libgettextpo %mklibname gettextpo %{major}
%define libgettextmisc %mklibname gettextmisc

%bcond_with check
%bcond_with csharp
%bcond_with java
%{?build_emacs}%{?!build_emacs:%bcond_without emacs}

Summary:	GNU libraries and utilities for producing multi-lingual messages
Name:		gettext
Version:	0.19.4
Release:	1
License:	GPLv3+ and LGPLv2.1+
Group:		System/Internationalization
Url:		http://www.gnu.org/software/gettext/
Source0:	ftp://ftp.gnu.org/pub/gnu/%{name}/%{name}-%{version}.tar.gz
Source2:	po-mode-init.el
# Missing in 0.19.1 tarball
Source3:	git-version-gen
Source100:	%{name}.rpmlintrc
# KDE example comes from 2003, it's really useless now
Patch0:		gettext-0.19.1-drop-kde-example.patch
Patch1:		gettext-0.18.1.1-stdio-gets.patch

BuildRequires:	bison
BuildRequires:	chrpath
%if %{with emacs}
BuildRequires:	emacs-nox
%endif
BuildRequires:	flex
BuildRequires:	texinfo
BuildRequires:	acl-devel
BuildRequires:	gomp-devel
BuildRequires:	libunistring-devel
BuildRequires:	pkgconfig(libcroco-0.6)
BuildRequires:	pkgconfig(ncursesw)
BuildRequires:	pkgconfig(libxml-2.0)
%if %{with check}
# test suite
BuildRequires:	locales-fa
BuildRequires:	locales-fr
BuildRequires:	locales-ja
BuildRequires:	locales-zh
%endif
%if %{with csharp}
# (Abel) we pick mono here, though pnet can be used as well.
BuildRequires:	mono
%endif
%if %{with java}
BuildRequires:	eclipse-ecj
BuildRequires:	gcc-java
BuildRequires:	gcj-tools
BuildRequires:	fastjar
%endif

Requires:	%{name}-base = %{version}-%{release}
Requires:	%{libgettextmisc} = %{version}-%{release}
# xgettext will dlopen() it when extracting strings from glade files
Requires:	%mklibname expat 1

%description
The GNU gettext package provides a set of tools and documentation for producing
multi-lingual messages in programs. Tools include a set of conventions about
how programs should be written to support message catalogs, a directory and
file naming organization for the message catalogs, a runtime library which
supports the retrieval of translated messages, and stand-alone programs for
handling the translatable and the already translated strings. Gettext provides
an easy to use library and tools for creating, using, and modifying natural
language catalogs and is a powerful and simple method for internationalizing
programs.

If you would like to internationalize or incorporate multi-lingual messages
into programs that you're developing, you should install gettext.

%files
%doc AUTHORS README COPYING gettext-runtime/ABOUT-NLS gettext-runtime/BUGS NEWS THANKS
%if %{with emacs}
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*.el
%endif
%{_bindir}/envsubst
%{_bindir}/gettext.sh
%{_bindir}/msg*
%{_bindir}/recode-sr-latin
%{_bindir}/xgettext
%dir %{_datadir}/gettext
%{_datadir}/%{name}/msgunfmt.tcl
%{_datadir}/%{name}/projects
%{_datadir}/%{name}/javaversion.class
%{_datadir}/%{name}/styles
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/hostname
%{_libdir}/%{name}/project-id
%{_libdir}/%{name}/urlget
%{_libdir}/%{name}/user-email
%if %{with java}
%exclude %{_libdir}/%{name}/gnu.gettext.*
%endif
%{_infodir}/gettext.*
%if %{with emacs}
%{_datadir}/emacs/site-lisp/*.el*
%endif
%{_mandir}/man1/envsubst.*
%{_mandir}/man1/msg*
%{_mandir}/man1/xgettext.*
%{_mandir}/man1/recode-sr-latin.*

#----------------------------------------------------------------------------

%package -n %{libintl}
Summary:	Basic libintl library for internationalization
Group:		System/Libraries
License:	LGPLv2.1+
Provides:	libintl = %{version}-%{release}

%description -n %{libintl}
This package contains the libintl library, which is important for
system internationalization.

%files -n %{libintl}
/%{_lib}/libintl.so.%{intl_major}*

#----------------------------------------------------------------------------

%package -n %{libasprintf}
Summary:	%{name} libasprintf needed by %{name} utilities
Group:		System/Libraries
License:	LGPLv2.1+
Conflicts:	%{_lib}gettextmisc < 0.18.1.1-4

%description -n %{libasprintf}
This package contains libasprintf shared library.

%files -n %{libasprintf}
%{_libdir}/libasprintf.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libgettextpo}
Summary:	%{name} libgettextpo needed by %{name} utilities
Group:		System/Libraries
License:	LGPLv2.1+
Conflicts:	%{_lib}gettextmisc < 0.18.1.1-4

%description -n %{libgettextpo}
This package contains libgettextpo shared library.

%files -n %{libgettextpo}
%{_libdir}/libgettextpo.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libgettextmisc}
Summary:	Other %{name} libraries needed by %{name} utilities
Group:		System/Libraries
License:	LGPLv2.1+

%description -n %{libgettextmisc}
This package contains all other libraries used by %{name} utilities,
and are not very widely used outside %{name}.

%files -n %{libgettextmisc}
%{_libdir}/libgettextlib-*.so
%{_libdir}/libgettextsrc-*.so

#----------------------------------------------------------------------------

%package devel
Summary:	Development files for %{name}
Group:		Development/C
License:	LGPLv2.1+
Requires:	%{name} = %{EVRD}
Requires:	%{libgettextpo} = %{EVRD}
Requires:	%{libasprintf} = %{EVRD}
Requires:	%{libgettextmisc} = %{EVRD}
Requires:	%{libintl} = %{EVRD}
# fwang: autopoint requires cvs to work
Requires:	cvs

%description devel
This package contains all development related files necessary for
developing or compiling applications/libraries that needs
internationalization capability. You also need this package if you
want to add gettext support for your project.

%files devel
%doc gettext-runtime/man/*.3.html examples htmldoc
%{_bindir}/autopoint
%{_bindir}/gettextize
%{_datadir}/%{name}/ABOUT-NLS
%{_datadir}/%{name}/archive*
%{_datadir}/%{name}/config.rpath
%{_datadir}/%{name}/*.h
%{_datadir}/%{name}/intl
%{_datadir}/%{name}/po
%{_datadir}/aclocal/*
%{_includedir}/*
%{_infodir}/autosprintf*
# "lib*.so" cannot be used (it should be 'lib[^\.]*\.so' regexp in fact
# but using regexp is not possible here; so we list all files manually
%{_libdir}/libasprintf.so
%{_libdir}/libgettextlib.so
%{_libdir}/libgettextpo.so
%{_libdir}/libgettextsrc.so
%{_libdir}/libintl.so
%{_mandir}/man1/autopoint.*
%{_mandir}/man3/*

#----------------------------------------------------------------------------

%package base
Summary:	Basic binary for showing translation of textual messages
Group:		System/Internationalization
Requires:	%{libintl} = %{EVRD}

%description base
This package contains the basic binary from %{name}. It is splitted from
%{name} because initscript need it to show translated boot messages.

%files base -f %{name}.lang
%doc gettext-runtime/man/*.1.html
%doc gettext-runtime/intl/COPYING*
/bin/gettext
%{_bindir}/gettext
%{_bindir}/ngettext
%{_mandir}/man1/gettext*
%{_mandir}/man1/ngettext*

#----------------------------------------------------------------------------

%if %{with java}
%package java
Summary:	Java binding for GNU gettext
Group:		System/Internationalization
Requires:	%{name} = %{version}

%description java
This package contains class file that implements the main GNU libintl
functions in Java. This allows compiling GNU gettext message catalogs
into Java ResourceBundle classes.

%files java
%doc gettext-runtime/intl-java/javadoc*
%{_libdir}/%{name}/gnu.gettext.*
%{_datadir}/%{name}/*.jar
%endif

#----------------------------------------------------------------------------

%if %{with csharp}
%package csharp
Summary:	C# binding for GNU gettext
Group:		System/Internationalization
Requires:	mono
Requires:	%{name} = %{version}

%description csharp
This package contains class file that implements the main GNU libintl
functions in C#. This allows compiling GNU gettext message catalogs
into C# dll or resource files.

%files csharp
%doc gettext-runtime/intl-csharp/csharpdoc/*
%{_libdir}/*.dll
%{_libdir}/gettext/*.exe
%endif

#----------------------------------------------------------------------------

%prep
%setup -q
%apply_patches
install -m 755 %{SOURCE3} build-aux/

%build
autoreconf -fi
%if %{with java}
export GCJ="%{_bindir}/gcj"
export JAVAC="%{_bindir}/gcj -C"
export JAR="%{_bindir}/fastjar"
%endif

for i in `find -name configure|sort`
do
pushd `dirname $i`
CONFIGURE_TOP=. \
%configure2_5x \
	--disable-static \
	--disable-rpath \
	--enable-shared \
	--with-included-gettext \
%if %{with csharp}
	--enable-csharp=mono \
%else
	--disable-csharp \
%endif
%if ! %{with java}
	--disable-java
%endif

popd
done

%make

%if %{with check}
%check
export JAVAC=ecj
LC_ALL=C make check
%endif

%install
%makeinstall_std

# remove unwanted files
rm -f %{buildroot}%{_includedir}/libintl.h \
      %{buildroot}%{_datadir}/locale/locale.alias
rm -f gettext-runtime/intl-java/javadoc2/package-list

%if %{with emacs}
install -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/emacs/site-start.d/%{name}.el
%endif

# remove non-standard lc directories
for i in en@boldquot en@quot ; do rm -rf %{buildroot}/%{_datadir}/locale/$i; done

# move installed doc back to %%doc
rm -rf htmldoc examples
mkdir htmldoc
for i in gettext-runtime/man/*.html; do
  rm -f %{buildroot}%{_datadir}/doc/gettext/`basename $i`
done
rm -rf %{buildroot}%{_datadir}/doc/gettext/javadoc*
mv %{buildroot}%{_datadir}/doc/gettext/* %{buildroot}/%{_datadir}/doc/libasprintf/* htmldoc
mv htmldoc/examples examples

# move crucial stuff to /lib and /bin
pushd %{buildroot}
mkdir -p bin
mkdir -p ./%{_lib}
mv usr/bin/gettext bin/
ln -s ../../bin/gettext usr/bin/gettext
mv .%{_libdir}/libintl.so.* ./%{_lib}/
rm -f .%{_libdir}/libintl.so
# if major changed, then package build will fail, which is a GOOD THING.
# this prevents mindless packaging.
[ -f %{_lib}/libintl.so.%{intl_major} ] && \
  ln -s ../../%{_lib}/libintl.so.%{intl_major} .%{_libdir}/libintl.so
popd

# remove java stuff, otherwise rpm complains
%if !%{with java}
rm -f %{buildroot}%{_libdir}/%{name}/gnu.gettext.* \
      %{buildroot}%{_datadir}/%{name}/*.jar
%endif

# cleanup rpaths
for i in %{buildroot}%{_bindir}/* `find %{buildroot}%{_libdir} -type f`; do
    if file $i | grep "ELF 64-bit" >/dev/null; then
	chrpath -l $i && chrpath --delete $i
    fi
done

%find_lang %{name} --all-name


%changelog

* Wed Apr 08 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.19.4-1
- (e468797) New version 0.19.4


